From 67e12c5a94df57cd6a72a93b542eaff35f226d10 Mon Sep 17 00:00:00 2001
From: Martin Fick <mfick@codeaurora.org>
Date: Thu, 3 Feb 2011 18:06:11 -0700
Subject: [PATCH 7/7] Add ability to save any search from the query result screen

Change-Id: I24054a584ec9e41957c3b007d32dc362724ff070
---
 .../gerrit/client/changes/ChangeConstants.java     |    2 +
 .../client/changes/ChangeConstants.properties      |    2 +
 .../google/gerrit/client/changes/QueryScreen.java  |   45 +++++++++++++++++++-
 .../com/google/gerrit/client/changes/Util.java     |    5 ++
 4 files changed, 53 insertions(+), 1 deletions(-)

diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java
index abdaa15..20e8e92 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java
@@ -24,6 +24,8 @@ public interface ChangeConstants extends Constants {
 
   String changesRecentlyClosed();
 
+  String buttonSaveSearch();
+
   String starredHeading();
   String watchedHeading();
   String draftsHeading();
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties
index 7cd0208..f202436 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties
@@ -3,6 +3,8 @@ statusLongSubmitted = Submitted, Merge Pending
 statusLongMerged = Merged
 statusLongAbandoned = Abandoned
 
+buttonSaveSearch = Save Search
+
 starredHeading = Starred Changes
 watchedHeading = Open Changes of Watched Projects
 draftsHeading = Changes with unpublished drafts
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/QueryScreen.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/QueryScreen.java
index 1192dd0..3413bde 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/QueryScreen.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/QueryScreen.java
@@ -15,15 +15,23 @@
 package com.google.gerrit.client.changes;
 
 import com.google.gerrit.client.Gerrit;
+import com.google.gerrit.client.Dispatcher;
 import com.google.gerrit.client.rpc.GerritCallback;
+import com.google.gerrit.client.searches.SearchEditor;
 import com.google.gerrit.common.PageLinks;
 import com.google.gerrit.common.data.ChangeInfo;
 import com.google.gerrit.common.data.SingleListChangeInfo;
+import com.google.gerrit.reviewdb.Account;
+import com.google.gerrit.reviewdb.Search;
 import com.google.gerrit.reviewdb.RevId;
+
+import com.google.gwt.event.dom.client.ClickEvent;
+import com.google.gwt.event.dom.client.ClickHandler;
+import com.google.gwt.user.client.History;
 import com.google.gwt.user.client.rpc.AsyncCallback;
+import com.google.gwt.user.client.ui.Button;
 import com.google.gwtorm.client.KeyUtil;
 
-
 public class QueryScreen extends PagedSingleListScreen implements
     ChangeListScreen {
   public static QueryScreen forQuery(String query) {
@@ -35,6 +43,8 @@ public class QueryScreen extends PagedSingleListScreen implements
   }
 
   private final String query;
+  protected SearchEditor editor;
+  private Button save;
 
   public QueryScreen(final String encQuery, final String positionToken) {
     super("q," + encQuery, positionToken);
@@ -46,6 +56,39 @@ public class QueryScreen extends PagedSingleListScreen implements
     super.onInitUI();
     setWindowTitle(Util.M.changeQueryWindowTitle(query));
     setPageTitle(Util.M.changeQueryPageTitle(query));
+
+    editor = new SearchEditor(null) {
+      @Override
+      public void onSaveSuccess(Search updated, String linkName) {
+        setVisible(false);
+        History.newItem(Dispatcher.toSearches(updated.getType(),
+          linkName));
+      }
+
+      @Override
+      public void onCancel() {
+        super.onCancel();
+        setVisible(false);
+        save.setVisible(true);
+      }
+    };
+    editor.setVisible(false);
+
+    save = new Button(Util.C.buttonSaveSearch());
+    save.addClickHandler(new ClickHandler() {
+      public void onClick(ClickEvent event) {
+        save.setVisible(false);
+        editor.setSearch(new Search(null, null, query));
+        editor.setVisible(true);
+      }
+    });
+
+    add(save);
+    add(editor);
+
+    if (! Gerrit.isSignedIn()) {
+      save.setVisible(false);
+    }
   }
 
   @Override
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java
index a7d468e..4152ff9 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java
@@ -17,6 +17,7 @@ package com.google.gerrit.client.changes;
 import com.google.gerrit.common.data.ChangeDetailService;
 import com.google.gerrit.common.data.ChangeListService;
 import com.google.gerrit.common.data.ChangeManageService;
+import com.google.gerrit.common.data.SearchService;
 import com.google.gerrit.reviewdb.Change;
 import com.google.gwt.core.client.GWT;
 import com.google.gwtjsonrpc.client.JsonUtil;
@@ -29,6 +30,7 @@ public class Util {
   public static final ChangeDetailService DETAIL_SVC;
   public static final ChangeListService LIST_SVC;
   public static final ChangeManageService MANAGE_SVC;
+  public static final SearchService SEARCH_SVC;
 
   static {
     DETAIL_SVC = GWT.create(ChangeDetailService.class);
@@ -39,6 +41,9 @@ public class Util {
 
     MANAGE_SVC = GWT.create(ChangeManageService.class);
     JsonUtil.bind(MANAGE_SVC, "rpc/ChangeManageService");
+
+    SEARCH_SVC = GWT.create(SearchService.class);
+    JsonUtil.bind(SEARCH_SVC, "rpc/SearchService");
   }
 
   public static String toLongString(final Change.Status status) {
-- 
1.7.4.1

